/******************************************************************************/
/* CC-BY license
 * http://mathrax.com/lab/?p=1326
 * by MATHRAX and FUJITSU.
 *
/* CC-BY-SA license
/* http://dangerousprototypes.com/forum/viewtopic.php?f=56&t=3472
/* by Markus Gritsch.
/*
/* CC-BY license
/* http://elm-chan.org/works/mxb/report_j.html
/* by ELM ChaN.
/*
/******************************************************************************/
/*  Files to Include                                                          */
/******************************************************************************/
#include <xc.h>             /* Defines special funciton registers, CP0 regs  */
#include <plib.h>           /* Include to use PIC32 peripheral libraries      */
#include <stdint.h>         /* For uint32_t definition                        */
#include <stdbool.h>        /* For true/false definition                      */

#include "system.h"         /* System funct/params, like osc/periph config    */
#include "user.h"           /* User funct/params, such as InitApp             */

#include "wavetable.h"      //Ff[^
#include "musicdata.h"      //yf[^

/******************************************************************************/
/* Global Variable Declaration                                                */
/******************************************************************************/

#define POT 9               //̍ilقǍA傫قǒႭj
#define ENVPOT 7            //Gx[v̒ilقǒZA傫قǒj
#define OSCILLATOR_COUNT 16 //ai8~64xB傫ȂƌvZɎԂ̂ŉcށj
#define TICKS_LIMIT 30      //e|
#define CLIP 1016           //l傫Ȃ肷Ȃ悤Ƀ~bg߂i127*8=1016܂Łj

/******************************************************************************/
/* Main Program                                                               */

/******************************************************************************/

int32_t main(void) {

    SYSTEMConfigPerformance(SYS_FREQ);

    InitApp();

    INTEnableSystemMultiVectoredInt();

    //CHECK START-UP (LED BLINK)
    uint8_t i;
    for (i = 0; i < 5; i++) {
        //ACTIVE LOW
        LED = 0;
        DelayMs(100);
        LED = 1;
        DelayMs(100);
    }

    uint16_t increments_pot[ OSCILLATOR_COUNT ];
    uint32_t phase_accu_pot[ OSCILLATOR_COUNT ];
    uint32_t envelope_positions_envpot[ OSCILLATOR_COUNT ];

    uint8_t osc;
    for (osc = 0; osc < OSCILLATOR_COUNT; ++osc) {
        increments_pot[ osc ] = 0;
        phase_accu_pot[ osc ] = 0;
        envelope_positions_envpot[ osc ] = 0;
    }

    uint8_t next_osc = 0;
    uint16_t ticks = 0;
    uint32_t time = 0;
    uint16_t event_index = 0;

    
    const uint16_t event_count = sizeof ( treering_data) / sizeof ( treering_data[ 0 ]);
    const uint32_t sizeof_wt_sustain_pot = ((uint32_t)sizeof (wt_sustain) << POT);
    const uint32_t sizeof_wt_attack_pot = ((uint32_t)sizeof (wt_attack) << POT);
    const uint32_t sizeof_wt_pot = sizeof_wt_attack_pot + sizeof_wt_sustain_pot;
    const uint32_t sizeof_envelope_table_envpot = ((uint32_t)sizeof ( envelope_table) << ENVPOT);

    while (1) {

        while (time >= treering_data[ event_index ].time) {
            increments_pot[ next_osc ] = scale_table[scale[ treering_data[ event_index ].pitch ]];
            phase_accu_pot[ next_osc ] = 0;

            envelope_positions_envpot[ next_osc ] = 0;
            ++next_osc;
            if (next_osc >= OSCILLATOR_COUNT) {
                next_osc = 0;
            }
            ++event_index;
            if (event_index >= event_count) {
                ticks = 0;
                time = 0;
                event_index = 0;
            }
        }

        ++ticks;
        if (ticks >= TICKS_LIMIT) {
            ticks = 0;
            time += 1;
        }

        int32_t value = 0;

        uint8_t osc;

        for (osc = 0; osc < OSCILLATOR_COUNT; ++osc) {

            phase_accu_pot[ osc ] += increments_pot[ osc ];
            if (phase_accu_pot[ osc ] >= sizeof_wt_pot) {
                phase_accu_pot[ osc ] -= sizeof_wt_sustain_pot;
            }
            uint16_t phase_accu = (phase_accu_pot[ osc ] >> POT);
            value += envelope_table[ envelope_positions_envpot[ osc ] >> ENVPOT ] * (*(wt_attack + phase_accu));
            if (phase_accu_pot[ osc ] >= sizeof_wt_attack_pot &&
                    envelope_positions_envpot[ osc ] < sizeof_envelope_table_envpot - 1) {
                ++envelope_positions_envpot[ osc ];
            }

        }
        value >>= 8;
        if (value > CLIP) {
            value = CLIP;
        } else if (value < -CLIP) {
            value = -CLIP;
        }

        while (TMR2 > 10) {
        }
        OC1RS = (1024 + value);


    }
}
