/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/
#include <xc.h>          /* Defines special funciton registers, CP0 regs  */

#include <plib.h>            /* Include to use PIC32 peripheral libraries     */
#include <stdint.h>          /* For uint32_t definition                       */
#include <stdbool.h>         /* For true/false definition                     */

#include "system.h"
#include "user.h"            /* variables/params used by user.c               */
/******************************************************************************/
/* User Functions                                                             */
/******************************************************************************/

/* TODO Initialize User Ports/Peripherals/Project here */

void InitApp(void) {
    /* Setup analog functionality and port direction */

    /* Initialize peripherals */
    ANSELA = 0x0000; 
    ANSELB = 0x0000;


    TRIS_LED = 0;
    LED = 1;

    TRIS_SPEAKER = 0;

    TRIS_AMP_CE = 0;
    AMP_CE = 0;

    InitPwm();
}


void InitPwm(void) {
    OpenOC1(OC_ON | OC_TIMER2_SRC | OC_PWM_FAULT_PIN_DISABLE, 0, 0);
    OpenTimer2(T2_ON | T2_PS_1_1 | T2_SOURCE_INT, 2047); 

    OC1RS = 0;

    RPB3Rbits.RPB3R = 5; //OC1
}

 //*****************************************************************************
 // DelayMs creates a delay of given miliseconds using the Core Timer
 //
 void DelayMs(WORD delay)
 {
     unsigned int int_status;
     while( delay-- )
     {
         int_status = INTDisableInterrupts();
         OpenCoreTimer(SYS_FREQ / 2000);
         INTRestoreInterrupts(int_status);
         mCTClearIntFlag();
         while( !mCTGetIntFlag() );
     }
     mCTClearIntFlag();
 }